#include "controller.h"

extern unsigned char controller_status;
unsigned char controller_xor_status;

void init_controller(){
	PORTSetPinsDigitalOut(CTRL_LATCH_PORT, CTRL_LATCH);
    PORTSetPinsDigitalOut(CTRL_CLK_PORT, CTRL_CLK);
    PORTSetPinsDigitalIn(CTRL_DATA_PORT, CTRL_DATA);
    
    PORTClearBits(CTRL_LATCH_PORT, CTRL_LATCH);
    PORTClearBits(CTRL_CLK_PORT, CTRL_CLK);
}

void update_controller(unsigned char* status, void (*delay_us_func)(int)){
	unsigned char controller_data = 0; 
    PORTClearBits(CTRL_LATCH_PORT, CTRL_LATCH);
    PORTClearBits(CTRL_CLK_PORT, CTRL_CLK); //Set LATCH, CLK low
    
    PORTSetBits(CTRL_LATCH_PORT, CTRL_LATCH); //Set LATCH high
        
    delay_us_func(2);//yield for 2 msec 
    PORTClearBits(CTRL_LATCH_PORT, CTRL_LATCH); //Set LATCH low
        
	if (PORTReadBits(CTRL_DATA_PORT, CTRL_DATA)) controller_data = 1; // Read DATA
	int i;
	for (i = 1; i <= 7; i ++) {
	    PORTSetBits(CTRL_CLK_PORT, CTRL_CLK); //Set CLK high
	    delay_us_func(2);//yield for 2 msec 
	    controller_data = controller_data << 1; // Read DATA and shift left 1
	    if (PORTReadBits(CTRL_DATA_PORT, CTRL_DATA)) controller_data += 1;
	    delay_us_func(3);//yield for 3 msec 
        PORTClearBits(CTRL_CLK_PORT, CTRL_CLK); //Set CLK low
        delay_us_func(1);//yield for 3 msec 
	}
    controller_xor_status = (~controller_data)^(*status);
    *status = ~controller_data;
}

int getbuttondown(unsigned char key){
	return ((controller_status & key) != 0) ? 1 : 0;
}

int getbuttontoggle(unsigned char key){
    return ((controller_xor_status & key) != 0) ? 1 : 0;
}