#include "config.h"
#include "pt_cornell_1_2.h"

#include "game_manager.h"

#include <math.h>

static struct pt pt_controller, pt_update;

extern game_manager_t gm;

// Controller Thread
unsigned char controller_status = 0;
static PT_THREAD (protothread_ctrl(struct pt *pt))
{
    PT_BEGIN(pt);
    while(1)
    {
        update_controller(&controller_status, delay_us);
        PT_YIELD_TIME_msec(10);
    }
    PT_END(pt);
}

// ==== MAIN UPDATE THREAD =============

extern volatile int time_tick_60_hz;
static PT_THREAD (protothread_update(struct pt *pt)){
    PT_BEGIN(pt);
    while(1){
        gm.update_func(30);
        PT_YIELD_TIME_msec(30);
    }
    PT_END(pt);
}

// main function to init and start everything
void main(void){
    PT_setup();
    
    init_game_manager();
    
    PT_INIT(&pt_controller);
    PT_INIT(&pt_update);
    
    while(1){
        PT_SCHEDULE(protothread_ctrl(&pt_controller));
        PT_SCHEDULE(protothread_update(&pt_update));
    }
    return;
}