#include "game_manager.h"

extern char key_old;
char aud_btn_pressed, aud_btn_pressed_old;
// ======== sprites ========
char aud_btn_1_txt[6];
int hit_sound_state = 0;
void demo_audio_button_1_update(sprite_t* s, int dt){
    if (aud_btn_pressed != aud_btn_pressed_old){
        if (aud_btn_pressed){
            video_fillRoundRect((s->pos.x - s->width/2), (s->pos.y - s->height/2), s->width, s->height, 3, DRAW_WHITE);
            video_removestring(s->pos.x - 18, s->pos.y-4, aud_btn_1_txt);
            config_hit(hit_sound_state++);
            if (hit_sound_state > 2) hit_sound_state = 0;
            DmaChnEnable(DMAhit);
        } else {
            video_fillRoundRect((s->pos.x - s->width/2), (s->pos.y - s->height/2), s->width, s->height, 3, DRAW_BLACK);
            video_drawRoundRect((s->pos.x - s->width/2), (s->pos.y - s->height/2), s->width, s->height, 3, OPT_OVERLAY);
            video_string(s->pos.x - 18, s->pos.y-4, aud_btn_1_txt);
        }
    }
}

void demo_audio_button_1_init(sprite_t* s, int dt){
    s->width = 50;
    s->height = 20;
    vector2d pos = {(right+left)/2,(top+bottom)/2};
    s->pos = pos;
    s->update_func = demo_audio_button_1_update;
    sprintf(aud_btn_1_txt, "HIT ME");
    video_drawRoundRect((s->pos.x - s->width/2), (s->pos.y - s->height/2), s->width, s->height, 3, OPT_OVERLAY);
    video_string(s->pos.x - 18, s->pos.y-4, aud_btn_1_txt);
}

sprite_t demo_audio_button_1 = {0,0,0,0,0,0,demo_audio_button_1_init,0,0};
// ======== scene ========

void scene_demo_audio_update(scene_t* s, int dt){
    int i;
    
    if (getbuttondown(KEY_A)){
        aud_btn_pressed = 1;
        key_old |= (1 << 2);
    } else {
        aud_btn_pressed = 0;
        key_old &= ~(1 << 2);
    }
    
    // update its children sprites first
    for (i = 0; i < s->nsprite; i++){
        s->sprites[i]->update_func(s->sprites[i], 0);
    }
    
    if (getbuttondown(KEY_DOWN)){
        if (!(key_old & 1)) {
            config_hit(0);
            DmaChnEnable(DMAhit);
            game_manager_load_scene(7);
        }
        key_old |= 1;
    } else {
        key_old &= ~(1<<0);
    }
    
    if (getbuttondown(KEY_UP)){
        if (!(key_old & (1<<1))) {
            config_hit(0);
            DmaChnEnable(DMAhit);
            game_manager_load_scene(7);
        }
        key_old |= (1 << 1);
    } else {
        key_old &= ~(1 << 1);
    }
    
    if (getbuttondown(KEY_B)){
        if (!(key_old & (1<<3))) {
            config_hit(0);
            DmaChnEnable(DMAhit);
            game_manager_load_scene(0);
        }
        key_old |= (1 << 3);
    } else {
        key_old &= ~(1 << 3);
    }
    
    aud_btn_pressed_old = aud_btn_pressed;
}

char title_str[20];
char help_str[20];

sprite_t* audio_sprites[1];

void scene_demo_audio_init(scene_t* s, int dt){
    int i;
    video_clr();
    
    s->nsprite = 1;
    
    s->sprites = audio_sprites;
    s->sprites[0] = &demo_audio_button_1;
    //s->sprites[1] = &demo_audio_button_2;
    
    for (i = 0; i < s->nsprite; i++){
        s->sprites[i]->init_func(s->sprites[i], 0);
    }
    
    s->update_func = scene_demo_audio_update;
    
    // init the scene here
    // Draw the screen boundaries
    video_line(left+30,top+25, right-30,top+25, 1); // top
    video_line(right-30,top+25, right-30,bottom-25, 1); // right
    video_line(right-30,bottom-25, left+30,bottom-25, 1); // bottom
    video_line(left+30,top+25, left+30,bottom-25 ,1); // left
    
    sprintf(title_str, "Audio Switching");
    video_string((left+right)/2-37, top+35, title_str);
    
    sprintf(help_str, "Press B to return.");
    video_string(left+5, bottom-8, help_str);
    
    DmaChnDisable(DMAbgm);
}

scene_t scene_demo_audio = {scene_demo_audio_init, NULL, NULL, 0}; // scene 6